#include <Servo.h>
#include <Bridge.h>
#include <YunClient.h>
#include <CapacitiveSensor.h>

YunClient client;
byte ip[] = {192, 168, 43, 247};
int port = 5587;

class TacSensor{
    public:
        uint8_t pin1, pin2;
        long value;
        const uint8_t* reperto;
        CapacitiveSensor sensor = CapacitiveSensor(pin1, pin2);

        TacSensor(uint8_t pinX, uint8_t pinY, const uint8_t* rep){
            pin1 = pinX;
            pin2 = pinY;
            reperto = rep;
        }
        
        void passaggio(){
            client.write(reperto,strlen(reperto));
        }
};

TacSensor* sensor1;
TacSensor* sensor2;
TacSensor* sensor3;

Servo servo1;
Servo servo2;
Servo servo3;

void setup(){
    servo1.attach(10);
    servo2.attach(9);
    servo3.attach(11);
    sensor1 = new TacSensor(2, 3, "venere");
    sensor2 = new TacSensor(4, 5, "anfora");
    sensor3 = new TacSensor(6, 7, "ercole");

    sensor1->sensor.set_CS_AutocaL_Millis(0xFFFFFFFF);
    sensor2->sensor.set_CS_AutocaL_Millis(0xFFFFFFFF);
    sensor3->sensor.set_CS_AutocaL_Millis(0xFFFFFFFF);

    pinMode(A0, OUTPUT);
    pinMode(A1, OUTPUT);
    pinMode(A2, OUTPUT);
    pinMode(A3, OUTPUT);
    pinMode(A4, OUTPUT);
    pinMode(A5, OUTPUT);
    pinMode(8, OUTPUT);
    

    Bridge.begin();
    Serial.begin(9600);
    client.connect(ip, port);
    if(client.connected()) Serial.println("connesso");
}

void loop(){
    sensor1->value = sensor1->sensor.capacitiveSensor(50);
    sensor2->value = sensor2->sensor.capacitiveSensor(50);
    sensor3->value = sensor3->sensor.capacitiveSensor(50);

    if(sensor1->value >= 1800){
        sensor1->passaggio();
        delay(500);
        servo1.write(180);
        delay(2000);
        servo1.write(90);
        delay(2000);     
    }
    else if(sensor2->value >= 1800){
        sensor2->passaggio();
        delay(500);
        servo2.write(180);
        delay(2000);
        servo2.write(90);
        delay(13200); 
        digitalWrite(A3, HIGH);
        delay(20000);
        digitalWrite(A3, LOW);
        digitalWrite(A4, HIGH);
        delay(13000);
        digitalWrite(A4, LOW);
        delay(500);
    }

    else if(sensor3->value >= 1800){
        sensor3->passaggio();
        delay(500);
        servo3.write(180);
        delay(2000);
        servo3.write(90);
        delay(14000);  
        digitalWrite(8, HIGH);
        delay(20000);
        digitalWrite(8, LOW);
        digitalWrite(A0, HIGH);
        delay(11000);
        digitalWrite(A0, LOW);
        delay(500);
  }
    //Serial.println(sensor2->value);
}
